`timescale 1ns / 1ps

module composite_mux
(
	input [3:0] i_spr_pix,
	input i_spr_bgpri,
	input i_spr_spr0,
	
	input [3:0] i_bg_pix,
	
	output [3:0] o_pix,
	output o_use_spr_pal,
	output o_spr0_hit
);

wire bg_trans = i_bg_pix == 4'b0;
wire spr_trans = i_spr_pix == 4'b0;

wire sel_obj = (!i_spr_bgpri || bg_trans) && !spr_trans;

assign o_pix = sel_obj ? i_spr_pix : i_bg_pix;
assign o_use_spr_pal = sel_obj;
assign o_spr0_hit = i_spr_spr0 & !bg_trans & !spr_trans;

endmodule
