`timescale 1ns / 1ps

module nes_iface
(
	input i_clk_54,
	input i_clk_17,
	input i_reset,
	
	input [2:0] i_nes_addr,
	input [7:0] i_nes_wr_data,
	output reg [7:0] o_nes_rd_data,
	input i_nes_read,
	input i_nes_write,
	
	output reg o_read,
	output reg o_write,
	output reg [2:0] o_addr,
	output reg [7:0] o_wr_data,
	input [7:0] i_rd_data,
	input i_rd_datavalid
);
	

// 5.4MHz
localparam S_CYCLE1 = 2'd0;
localparam S_CYCLE2 = 2'd1;
localparam S_CYCLE3 = 2'd2;
reg [1:0] state, nextstate;

always @ (posedge i_clk_54 or posedge i_reset) begin
	if (i_reset) begin
		state <= S_CYCLE1;
	end
	else begin
		state <= nextstate;
		
		if (i_rd_datavalid) begin
			o_nes_rd_data <= i_rd_data;
		end
	end
end

always @* begin
	nextstate = state;
	o_wr_data = i_nes_wr_data;
	o_addr = i_nes_addr;
	o_read = 1'b0;
	o_write = 1'b0;
	
	case (state)
	S_CYCLE1 : begin
		o_read = i_nes_read;
		o_write = i_nes_write;
		
		if (o_read || o_write) begin
			nextstate = S_CYCLE2;
		end
	end
	
	S_CYCLE2 : begin
		nextstate = S_CYCLE3;
	end
	
	S_CYCLE3 : begin
		nextstate = S_CYCLE1;
	end
		
	endcase
end
		
endmodule
