`timescale 1ns / 1ps

module nes_standalone
(
	input								MGT_CLK_N,
	input								MGT_CLK_P,
	input 							PROC_RESET_Z,
	
	output 							VGA_VSYNCH,
	output 							VGA_HSYNCH,
	output 							VGA_OUT_BLANK_Z,
	output 							VGA_COMP_SYNCH,
	output 							VGA_OUT_PIXEL_CLOCK,
	
	output [7:0] 					VGA_OUT_RED,
	output [7:0] 					VGA_OUT_GREEN,
	output [7:0] 					VGA_OUT_BLUE
);

wire OPB_Rst = ~PROC_RESET_Z;

wire clk1;
wire clk5;
wire clk25;
NESclks clkgen
(
	.clk75_n(MGT_CLK_N),
	.clk75_p(MGT_CLK_P),
	.clk1(clk1),
	.clk25(clk25),
	.clk5(clk5)
);


//reg [2:0] ppu_addr;
//reg [7:0] ppu_write_data;
wire [7:0] ppu_read_data;
//reg ppu_read;
//reg ppu_write;
wire [5:0] ppu_pixel;
wire ppu_pixel_valid;
wire [7:0] ppu_pixel_x;
wire [7:0] ppu_pixel_y;
ppu the_ppu
(
	.i_clk_54(clk5),
	.i_clk_17(clk1),
	.i_reset(OPB_Rst),
	
	.i_addr(3'd0),
	.i_wr_data(8'd0),
	.o_rd_data(ppu_read_data),
	.i_read(1'b0),
	.i_write(1'b0),
	
	.o_nmi(IP2INTC_Irpt),
	
	.o_pixel(ppu_pixel),
	.o_pixel_valid(ppu_pixel_valid),
	.o_pixel_x(ppu_pixel_x),
	.o_pixel_y(ppu_pixel_y)
);

vid_out vid_out_inst
(
	.clk25(clk25),
	.clk5(clk5),
	
	.pixel_colour(ppu_pixel),
	.colour_emphasis(2'b0),
	.reset(OPB_Rst),
	.write_pixel(ppu_pixel_valid),
	.pixel_x(ppu_pixel_x),
	.pixel_y(ppu_pixel_y),
	
	.VGA_VSYNCH(VGA_VSYNCH),
	.VGA_HSYNCH(VGA_HSYNCH),
	.VGA_OUT_BLANK_Z(VGA_OUT_BLANK_Z),
	.VGA_COMP_SYNCH(VGA_COMP_SYNCH),
	.VGA_OUT_PIXEL_CLOCK(VGA_OUT_PIXEL_CLOCK),
	
	.VGA_OUT_RED(VGA_OUT_RED),
	.VGA_OUT_GREEN(VGA_OUT_GREEN),
	.VGA_OUT_BLUE(VGA_OUT_BLUE)
);


endmodule
