`timescale 1ns / 1ps

module palette
(
	input i_clk,
	
	input [4:0] i_cpu_addr,
	input [5:0] i_cpu_wr_data,
	input i_cpu_write,
	output reg [5:0] o_cpu_rd_data,
	
	input [4:0] i_rend_addr,
	output [5:0] o_rend_data
);

reg [5:0] pal_mem [31:0];

initial begin
   $readmemh("pal_ram.init", pal_mem, 0, 31);
end

always @ (posedge i_clk) begin
	if (i_cpu_write) pal_mem[i_cpu_addr] <= i_cpu_wr_data;
	else o_cpu_rd_data <= pal_mem[i_cpu_addr];
end

assign o_rend_data = pal_mem[i_rend_addr];


endmodule
