`timescale 1ns / 1ps


module ppubridge_tb_v;

	// Inputs
	reg OPB_Clk;
	reg OPB_Rst;
	reg [31:0] OPB_ABus;
	reg [3:0] OPB_BE;
	reg [31:0] OPB_DBus;
	reg OPB_RNW;
	reg OPB_select;
	reg OPB_seqAddr;
	reg clk75_n;
	reg clk75_p;

	// Outputs
	wire [31:0] Sl_DBus;
	wire Sl_errAck;
	wire Sl_retry;
	wire Sl_toutSup;
	wire Sl_xferAck;
	wire IP2INTC_Irpt;

	// Instantiate the Unit Under Test (UUT)
	ppubridge uut (
		.OPB_Clk(OPB_Clk), 
		.OPB_Rst(OPB_Rst), 
		.Sl_DBus(Sl_DBus), 
		.Sl_errAck(Sl_errAck), 
		.Sl_retry(Sl_retry), 
		.Sl_toutSup(Sl_toutSup), 
		.Sl_xferAck(Sl_xferAck), 
		.OPB_ABus(OPB_ABus), 
		.OPB_BE(OPB_BE), 
		.OPB_DBus(OPB_DBus), 
		.OPB_RNW(OPB_RNW), 
		.OPB_select(OPB_select), 
		.OPB_seqAddr(OPB_seqAddr), 
		.IP2INTC_Irpt(IP2INTC_Irpt), 
		.clk75_n(clk75_n), 
		.clk75_p(clk75_p)
	);

	always #40 OPB_Clk = ~OPB_Clk;
	always #13.333 clk75_n = ~clk75_n;
	always #13.333 clk75_p = ~clk75_p;

	initial begin
		// Initialize Inputs
		OPB_Clk = 0;
		OPB_Rst = 1;
		OPB_ABus = 0;
		OPB_BE = 0;
		OPB_DBus = 0;
		OPB_RNW = 0;
		OPB_select = 0;
		OPB_seqAddr = 0;
		clk75_n = 1;
		clk75_p = 0;

		#100;
		OPB_Rst = 0;
		#1000;
        
		OPB_ABus = 32'h80000000;
		OPB_RNW = 0;
		OPB_DBus = 5;
		OPB_select = 1;
		@(posedge OPB_Clk);
		wait(Sl_xferAck);

		
		OPB_RNW = 1;
		OPB_select = 1;
		@(posedge OPB_Clk);
		@(posedge OPB_Clk);
		wait(Sl_xferAck);

      OPB_select = 0;
      #400;

		$stop;

	end
      
endmodule

