`timescale 1ns / 1ps

module spr_ram
(
	input i_clk,
	
	// Port A - CPU read/write
	input [7:0] i_cpu_addr,
	input i_cpu_write,
	input [7:0] i_cpu_wr_data,
	output reg [7:0] o_cpu_rd_data,
	
	// Port B - Renderer read
	input [7:0] i_rend_addr,
	output reg [7:0] o_rend_data
);


reg [7:0] spr_ram_mem [255:0];

initial begin
    $readmemh("spr_ram.init", spr_ram_mem, 0, 255);
end
    

always @ (posedge i_clk) begin
	if (i_cpu_write) spr_ram_mem[i_cpu_addr] <= i_cpu_wr_data;
	else o_cpu_rd_data <= spr_ram_mem[i_cpu_addr];
	
	o_rend_data <= spr_ram_mem[i_rend_addr];
end


endmodule
