`timescale 1ns / 1ps

module vidmem
(
	input i_clk,
	input [13:0] i_addr,
	input [7:0] i_wr_data,
	input i_write,
	input i_read,
	output [7:0] o_rd_data
);

reg [7:0] pat_tables[8191:0];
reg [7:0] name_tables[2047:0];

reg a13_reg;
reg [7:0] nt_rd_data;
reg [7:0] pat_rd_data;

initial begin
   $readmemh("name_tables.init", name_tables, 0, 2047);
	$readmemh("pat_tables.init", pat_tables, 0, 8191);
end

// To be replaced with external DIP-switch control
reg nt_a10;
always @* begin
	case (i_addr[11:10])
		2'b00 : nt_a10 = 1'b0;
		2'b01 : nt_a10 = 1'b1;
		2'b10 : nt_a10 = 1'b0;
		2'b11 : nt_a10 = 1'b1;
	endcase
end
wire [10:0] nt_addr = {nt_a10, i_addr[9:0]};

assign o_rd_data = a13_reg ? nt_rd_data : pat_rd_data;

always @ (posedge i_clk) begin
	a13_reg = i_addr[13];

	if (!i_addr[13] && i_write) pat_tables[i_addr[12:0]] <= i_wr_data;
	else pat_rd_data <= pat_tables[i_addr[12:0]];

	if (i_addr[13] && i_write) name_tables[nt_addr] <= i_wr_data;
	else nt_rd_data <= name_tables[nt_addr];
end

endmodule
